-#!/usr/bin/perl
+#!/usr/bin/env perl
#
use strict;
use warnings;
-use CSS::Minifier::XS;
+use CSS::Minifier::XS 0.07;
use File::Copy;
use File::Find;
+use File::Path qw(make_path);
use File::Slurp;
use File::Spec;
use Getopt::Long;
my %opt = parse_arguments();
## Generate the pages
+my %cache; # General cache object
do_doc( 'spec', $_ ) foreach @{ $opt{spec} || [] };
do_doc( 'filter', $_ ) foreach @{ $opt{filter} || [] };
do_web() if exists $opt{web};
## Add the exim-html-current symlink
print "Symlinking exim-html-current to exim-html-$opt{latest}\n";
-symlink( "$opt{docroot}/exim-html-$opt{latest}", "$opt{docroot}/exim-html-current" );
+unlink("$opt{docroot}/exim-html-current") if ( -l "$opt{docroot}/exim-html-current" );
+symlink( "exim-html-$opt{latest}", "$opt{docroot}/exim-html-current" )
+ || die "symlink to $opt{docroot}/exim-html-current failed";
## Generate the website files
sub do_web {
## Scan the web templates
find(
sub {
- my ($path) = substr( $File::Find::name, length("$opt{tmpl}/web"), length($File::Find::name) ) =~ m#^/*(.*)$#;
+ my ($path) =
+ substr( $File::Find::name, length("$opt{tmpl}/web"), length($File::Find::name) ) =~ m#^/*(.*)$#;
if ( -d "$opt{tmpl}/web/$path" ) {
## Build HTML from XSL files and simply copy static files which have changed
if ( $path =~ /(.+)\.xsl$/ ) {
- print "Generating : docroot:/$1.html\n";
+ print "Generating : docroot:/$1.html\n" if ( $opt{verbose} );
transform( undef, "$opt{tmpl}/web/$path", "$opt{docroot}/$1.html" );
}
elsif ( -f "$opt{tmpl}/web/$path" ) {
## Skip if the file hasn't changed (mtime based)
- return if -f "$opt{docroot}/$path" && ( stat("$opt{tmpl}/web/$path") )[9] == ( stat("$opt{docroot}/$path") )[9];
+ return
+ if -f "$opt{docroot}/$path"
+ && ( stat("$opt{tmpl}/web/$path") )[9] == ( stat("$opt{docroot}/$path") )[9];
if ( $path =~ /(.+)\.css$/ ) {
- print "CSS to : docroot:/$path\n";
+ print "CSS to : docroot:/$path\n" if ( $opt{verbose} );
my $content = read_file("$opt{tmpl}/web/$path");
- my $output = $opt{minify} ? CSS::Minifier::XS::minify($content) : $content;
- $output =~ s/and\(/and (/g; # hack round minify bug
- write_file( "$opt{docroot}/$path", $output );
+ write_file( "$opt{docroot}/$path",
+ $opt{minify} ? CSS::Minifier::XS::minify($content) : $content );
}
elsif ( $path =~ /(.+)\.js$/ ) {
- print "JS to : docroot:/$path\n";
+ print "JS to : docroot:/$path\n" if ( $opt{verbose} );
my $content = read_file("$opt{tmpl}/web/$path");
- write_file( "$opt{docroot}/$path", $opt{minify} ? JavaScript::Minifier::XS::minify($content) : $content );
+ write_file( "$opt{docroot}/$path",
+ $opt{minify} ? JavaScript::Minifier::XS::minify($content) : $content );
}
else {
## Copy
- print "Copying to : docroot:/$path\n";
+ print "Copying to : docroot:/$path\n" if ( $opt{verbose} );
copy( "$opt{tmpl}/web/$path", "$opt{docroot}/$path" ) or die "$path: $!";
}
## Set mtime
## Add the canonical url for this document
$xml->documentElement()
- ->appendTextChild( 'canonical_url',
+ ->appendTextChild( 'canonical_url',
"${canonical_url}exim-html-current/doc/html/spec_html/" . ( $type eq 'spec' ? 'index' : 'filter' ) . ".html" );
+ ## Add a url for the latest version of this document
+ if ( $version ne $opt{latest} ) {
+ $xml->documentElement()
+ ->appendTextChild( 'current_url',
+ "../../../../exim-html-current/doc/html/spec_html/" . ( $type eq 'spec' ? 'index' : 'filter' ) . ".html" );
+ }
+
## Fixup the XML
xref_fixup( $xml, $prepend_chapter );
## Generate a Table of Contents XML file
{
- my $path = "exim-html-$version/doc/html/spec_html/" . ( $type eq 'filter' ? 'filter_toc' : 'index_toc' ) . ".xml";
- print "Generating : docroot:/$path\n";
+ my $path =
+ "exim-html-$version/doc/html/spec_html/" . ( $type eq 'filter' ? 'filter_toc' : 'index_toc' ) . ".xml";
+ print "Generating : docroot:/$path\n" if ( $opt{verbose} );
transform( $xml, "$opt{tmpl}/doc/toc.xsl", "$opt{docroot}/$path", );
}
## Generate the chapters
my $counter = 0;
- foreach my $chapter ( map { $_->cloneNode(1) } $xml->findnodes('/book/chapter') ) {
+ my @chapters = map { $_->cloneNode(1) } $xml->findnodes('/book/chapter');
+ foreach my $chapter (@chapters) {
## Add a <chapter_id>N</chapter_id> node for the stylesheet to use
$chapter->appendTextChild( 'chapter_id', ++$counter );
$chapter->appendTextChild( 'prev_url',
$counter == 1
? $type eq 'filter'
- ? 'filter.html'
- : 'index.html'
+ ? 'filter.html'
+ : 'index.html'
: sprintf( '%sch%02d.html', $prepend_chapter, $counter - 1 ) );
- $chapter->appendTextChild( 'next_url', sprintf( '%sch%02d.html', $prepend_chapter, $counter + 1 ) );
- $chapter->appendTextChild( 'canonical_url',
- sprintf( 'http://www.exim.org/exim-html-current/doc/html/spec_html/%sch%02d.html', $prepend_chapter, $counter ) );
+ $chapter->appendTextChild( 'next_url', sprintf( '%sch%02d.html', $prepend_chapter, $counter + 1 ) )
+ unless int(@chapters) == $counter;
+ $chapter->appendTextChild(
+ 'canonical_url',
+ sprintf(
+ 'http://www.exim.org/exim-html-current/doc/html/spec_html/%sch%02d.html',
+ $prepend_chapter, $counter
+ )
+ );
+ if ( $version ne $opt{latest} ) {
+ $chapter->appendTextChild(
+ 'current_url',
+ sprintf(
+ '../../../../exim-html-current/doc/html/spec_html/%sch%02d.html',
+ $prepend_chapter, $counter
+ )
+ );
+ }
}
## Create an XML document from the chapter
## Transform the chapter into html
{
my $path = sprintf( 'exim-html-%s/doc/html/spec_html/%sch%02d.html', $version, $prepend_chapter, $counter );
- print "Generating : docroot:/$path\n";
+ print "Generating : docroot:/$path\n" if ( $opt{verbose} );
transform( $doc, "$opt{tmpl}/doc/chapter.xsl", "$opt{docroot}/$path", );
}
}
if ( exists $index{$linkend} ) {
$xref->setAttribute( 'chapter_id', $index{$linkend}{'chapter_id'} );
$xref->setAttribute( 'chapter_title', $index{$linkend}{'chapter_title'} );
- $xref->setAttribute( 'section_id', $index{$linkend}{'section_id'} ) if ( $index{$linkend}{'section_id'} );
- $xref->setAttribute( 'section_title', $index{$linkend}{'section_title'} ) if ( $index{$linkend}{'section_title'} );
+ $xref->setAttribute( 'section_id', $index{$linkend}{'section_id'} ) if ( $index{$linkend}{'section_id'} );
+ $xref->setAttribute( 'section_title', $index{$linkend}{'section_title'} )
+ if ( $index{$linkend}{'section_title'} );
$xref->setAttribute( 'url',
sprintf( '%sch%02d.html', $prepend_chapter, $index{$linkend}{'chapter_id'} )
- . ( $index{$linkend}{'section_id'} ? '#' . $linkend : '' ) );
+ . ( $index{$linkend}{'section_id'} ? '#' . $linkend : '' ) );
}
}
}
if ( $node->nodeName eq 'indexterm' ) {
my $role = $node->getAttribute('role') || 'concept';
my $primary = $node->findvalue('child::primary');
- my $first = ( $primary =~ /^[A-Za-z]/ ) ? uc( substr( $primary, 0, 1 ) ) : ''; # first letter or marker
+ my $first = ( $primary =~ /^[A-Za-z]/ ) ? uc( substr( $primary, 0, 1 ) ) : ''; # first letter or marker
my $secondary = $node->findvalue('child::secondary') || '';
- next unless ( $primary || $secondary ); # skip blank entries for now...
+ next unless ( $primary || $secondary ); # skip blank entries for now...
$index_hash->{$role}{$first}{$primary}{$secondary} ||= [];
push @{ $index_hash->{$role}{$first}{$primary}{$secondary} }, $current_id;
}
my $count = 0;
foreach my $ref ( @{ $index_hash->{$role}{$first}{$primary}{$secondary} } ) {
$para->appendText(', ')
- if ( $count++ );
+ if ( $count++ );
my $xrefel = XML::LibXML::Element->new('xref');
$xrefel->setAttribute( linkend => $ref );
$xrefel->setAttribute( longref => 1 );
## Add the current version of Exim to the XML
$xml->documentElement()->appendTextChild( 'current_version', $opt{latest} );
+ ## Add the old versions of Exim to the XML
+ $xml->documentElement()->appendTextChild( 'old_versions', $_ ) foreach old_docs_versions();
+
## Parse the ".xsl" file as XML
my $xsl = XML::LibXML->new()->parse_file($xsl_path) or die $!;
my $doc = $stylesheet->transform($xml);
## Make the containing directory if it doesn't exist
- mkdirp( ( $out_path =~ /^(.+)\/.+$/ )[0] );
+ make_path( ( $out_path =~ /^(.+)\/.+$/ )[0], { verbose => 1 } );
## Write out the document
- open my $out, '>', $out_path or die $!;
+ open my $out, '>', $out_path or die "Unable to write $out_path - $!";
print $out $stylesheet->output_as_bytes($doc);
close $out;
}
-## "mkdir -p "
-sub mkdirp {
- my $path = shift;
-
- my @parts = ();
- foreach ( split( /\//, $path ) ) {
- push @parts, $_;
- my $make = join( '/', @parts );
- next unless length($make);
- next if -d $make;
- mkdir($make) or die "Unable to mkdir $make: $!\n";
+## Look in the docroot for old versions of the documentation
+sub old_docs_versions {
+ if ( !exists $cache{old_docs_versions} ) {
+ my @versions;
+ foreach ( glob("$opt{docroot}/exim-html-*") ) {
+ push @versions, $1 if /-(\d+(?:\.\d+)?)$/ && $1 < $opt{latest} && -d $_;
+ }
+ $cache{old_docs_versions} = [ reverse sort { $a <=> $b } @versions ];
}
+ return @{ $cache{old_docs_versions} };
}
## error_help
## Parse arguments
sub parse_arguments {
- my %opt = ( spec => [], filter => [], help => 0, man => 0, web => 0, minify => 1 );
- GetOptions( \%opt, 'help|h!', 'man!', 'web!', 'spec=s{1,}', 'filter=s{1,}', 'latest=s', 'tmpl=s', 'docroot=s', 'minify!' )
- || pod2usage( -exitval => 1, -verbose => 0 );
+ my %opt = ( spec => [], filter => [], help => 0, man => 0, web => 0, minify => 1, verbose => 0 );
+ GetOptions(
+ \%opt, 'help|h!', 'man!', 'web!', 'spec=s{1,}', 'filter=s{1,}',
+ 'latest=s', 'tmpl=s', 'docroot=s', 'minify!', 'verbose!'
+ ) || pod2usage( -exitval => 1, -verbose => 0 );
## --help
pod2usage(0) if ( $opt{help} );
## --spec and --filter lists
foreach my $set (qw[spec filter]) {
- $opt{$set} = [ map { my $f = File::Spec->rel2abs($_); help( 1, 'No such file: ' . $_ ) unless -f $f; $f } @{ $opt{$set} } ];
+ $opt{$set} =
+ [ map { my $f = File::Spec->rel2abs($_); help( 1, 'No such file: ' . $_ ) unless -f $f; $f }
+ @{ $opt{$set} } ];
}
## --latest
error_help('Missing value for latest') unless ( exists( $opt{latest} ) && defined( $opt{latest} ) );
error_help('Excess arguments') if ( scalar(@ARGV) );
error_help('Must include at least one of --web, --spec or --filter')
- unless ( defined $opt{web} || scalar( @{ $opt{spec} } ) || scalar( @{ $opt{web} } ) );
+ unless ( $opt{web} || scalar( @{ $opt{spec} || [] } ) || scalar( @{ $opt{filter} || [] } ) );
return %opt;
}
=head1 COPYRIGHT
-Copyright 2010 Exim Maintainers. All rights reserved.
+Copyright 2010-2011 Exim Maintainers. All rights reserved.
=cut
-